/* Copyright 2012 Fredrik Wikstrom. All rights reserved.
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions
** are met:
**
** 1. Redistributions of source code must retain the above copyright
**    notice, this list of conditions and the following disclaimer.
**
** 2. Redistributions in binary form must reproduce the above copyright
**    notice, this list of conditions and the following disclaimer in the
**    documentation and/or other materials provided with the distribution.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS `AS IS'
** AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
** IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
** ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
** LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
*/

#include "cddapatch.h"
#include <proto/exec.h>
#include <proto/utility.h>
#include <stdarg.h>

VARARGS68K STRPTR ASPrintfPooled (APTR pool, CONST_STRPTR fmt, ...) {
	va_list args;
	va_startlinear(args, fmt);
	return VASPrintfPooled(pool, fmt, va_getlinearva(args, CONST_APTR));
	va_end(args);
}

static void CountChProc (TEXT c, uint32 *count) {
	(*count)++;
}

STRPTR VASPrintfPooled (APTR pool, CONST_STRPTR fmt, CONST_APTR args) {
	uint32 count = 0;
	STRPTR string;
	IExec->RawDoFmt(fmt, args, CountChProc, &count);
	string = IExec->AllocVecPooled(pool, count);
	if (string) {
		IUtility->VSNPrintf(string, count, fmt, args);
	}
	return string;
}
