/* Copyright 2012 Fredrik Wikstrom. All rights reserved.
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions
** are met:
**
** 1. Redistributions of source code must retain the above copyright
**    notice, this list of conditions and the following disclaimer.
**
** 2. Redistributions in binary form must reproduce the above copyright
**    notice, this list of conditions and the following disclaimer in the
**    documentation and/or other materials provided with the distribution.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS `AS IS'
** AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
** IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
** ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
** LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
*/

#include "cddapatch.h"
#include <proto/icon.h>
#include <proto/utility.h>
#include <string.h>
#include <stdlib.h>

BOOL TTBoolean (struct DiskObject *icon, CONST_STRPTR name) {
	CONST_STRPTR string;
	if (!icon) return FALSE;
	string = IIcon->FindToolType(icon->do_ToolTypes, name);
	return string && IUtility->Stricmp(string, "no") && IUtility->Stricmp(string, "false") && IUtility->Stricmp(string, "off");
}

int32 TTInteger (struct DiskObject *icon, CONST_STRPTR name, int32 def_value) {
	CONST_STRPTR string;
	if (!icon) return def_value;
	string = IIcon->FindToolType(icon->do_ToolTypes, name);
	return string ? atol(string) : def_value;
}

STRPTR TTString (struct DiskObject *icon, CONST_STRPTR name, STRPTR def_value) {
	STRPTR string;
	if (!icon) return def_value;
	string = IIcon->FindToolType(icon->do_ToolTypes, name);
	return string ? string : def_value;
}
